//
//  FirstViewController.m
//  LookGames
//
//  Created by Vitor Navarro on 5/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "FirstViewController.h"


@implementation FirstViewController

@synthesize search_bar = _search_bar;
@synthesize view_search_results = _view_search_results;
@synthesize results_table_view = _results_table_view;

#pragma mark - Search bar methods
-(void)searchBarCancelButtonClicked:(UISearchBar *)searchBar{
    [self.search_bar setText:@""];
    [self.search_bar setShowsCancelButton:NO animated:YES];
    [self.search_bar resignFirstResponder];
    [self.results_table_view.tableView setAllowsSelection:YES];
    [self.results_table_view.tableView setScrollEnabled:YES];
    
}
-(void)searchBarTextDidBeginEditing:(UISearchBar *)searchBar{
    [self.search_bar setShowsCancelButton:YES animated:YES];
    [self.results_table_view.tableView setAllowsSelection:NO];
    [self.results_table_view.tableView setScrollEnabled:NO];
    [UIView animateWithDuration:0.8 animations:^{
        [self.view_search_results setBackgroundColor:[UIColor blackColor]];
        self.view_search_results.alpha = 0.4;
    } completion:nil];
    
}
-(void)searchBarSearchButtonClicked:(UISearchBar *)searchBar{
    [self.results_table_view updateQuery:self.search_bar.text];
    [self.search_bar setShowsCancelButton:NO animated:YES];
    [self.search_bar resignFirstResponder];
    [self.results_table_view.tableView setAllowsSelection:YES];
    [self.results_table_view.tableView setScrollEnabled:YES];  
    [self.results_table_view updateTable];
    [UIView animateWithDuration:0.8 animations:^{
        [self.view_search_results setBackgroundColor:[UIColor clearColor]];
        self.view_search_results.alpha = 1;
    } completion:nil];
}

#pragma mark - Life Cycle

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    self.results_table_view = [[[ResultsTableViewController alloc]init]autorelease];
    
    [self.view_search_results addSubview:self.results_table_view.view];

}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload
{
    self.view_search_results = nil;
    self.search_bar = nil;
    self.results_table_view = nil;
    
    [super viewDidUnload];

    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc
{
    [_view_search_results release];
    [_search_bar release];
    [_results_table_view release];
    
    [super dealloc];
}

@end
