//
//  ResultsTableViewController.m
//  LookGames
//
//  Created by Navarro on 5/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ResultsTableViewController.h"


@implementation ResultsTableViewController
@synthesize table_cell_nib= _table_cell_nib;
@synthesize table_cell_temp = _table_cell_temp;


-(NSString *)formatValueForCell:(NSString *)value{
    if(value == nil || [value isEqualToString:@""]){
        return @"Unknow";
    }
    return value;
}

-(void)updateTable{
    //[self.tableView setDataSource:factual.current_result.rows];
    [self.tableView reloadData];
}

-(void)updateQuery:(NSString *)value{
    [factual executeQueryWithName:value];
}

-(void)registerNotification{
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(updateTable) 
                                                 name:FACTUAL_DATA 
                                               object:nil];    
}
-(void)unregisterNotification{
    [[NSNotificationCenter defaultCenter] removeObserver:self 
                                        name:FACTUAL_DATA 
                                        object:nil];
}

#pragma mark - View lifecycle

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        [self registerNotification];
        factual = [[FactualAccessor alloc] initWithAPIKey:@"SuVmilQqCBG1JQvgOygjGWwkM6c4LmbVMyJAc421oUdPSoWUg4lZsUnaoRS6RaL9"]; 
        [factual executeQueryWithName:@"kirby"];
    }
    return self;
}

- (void)dealloc
{
    [self unregisterNotification];
    [_table_cell_nib release];
    [_table_cell_temp release];
    [factual release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    self.table_cell_nib = [UINib nibWithNibName:@"ResultsTableCellView" bundle:nil];
    
    [self.tableView setRowHeight:150.0];
    self.tableView.frame = CGRectMake(0, 0, 320, 420);
//    self.tableView.frame.size.height = 340;
    //NSLog(@"%f",self.tableView.rowHeight);

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    self.table_cell_temp = nil;
    self.table_cell_nib = nil;
    factual = nil;
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    if(factual != nil && factual.current_result != nil)
        return factual.current_result.rowCount;
    else
        return 0;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"cell";
    
    ResultsTableCellViewController *cell = (ResultsTableCellViewController *)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil){
        
        [self.table_cell_nib instantiateWithOwner:self options:nil];
		cell = self.table_cell_temp;
		self.table_cell_temp = nil;
    }    
    // Configure the cell...
    FactualRow *row = [factual.current_result.rows objectAtIndex:indexPath.row];
    cell.lbl_title.text = [self formatValueForCell:[row stringValueForName:@"name"]];
    cell.lbl_genre.text = [self formatValueForCell:[row stringValueForName:@"genre"]];
    cell.lbl_platform.text = [self formatValueForCell:[row stringValueForName:@"platform"]];
    cell.lbl_publisher.text = [self formatValueForCell:[row stringValueForName:@"publisher"]];
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
}

@end
